
CoCoALib - Feature #400

add myJBMill member field to ideal

02 Aug 2013 17:43 - Anna Maria Bigatti

Status: New Start date: 02 Aug 2013

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: New Function Estimated time: 0.00 hour

Target version: CoCoALib-1.0 Spent time: 1.25 hour

Description

Related issues:

Related to CoCoALib - Feature #215: Janet Bases: check and include code in Co... Closed 02 Aug 2012

Related to CoCoALib - Design #455: Which sets of generators in an ideal? New 03 Mar 2014

Related to CoCoALib - Design #871: Redesign ideals New 26 Apr 2016

Related to CoCoALib - Design #921: Design GBMill New 16 Sep 2016

History

#1 - 29 Oct 2013 13:08 - Anna Maria Bigatti

- Target version set to CoCoALib-0.99532

#2 - 01 Apr 2014 19:27 - Anna Maria Bigatti

- Category set to New Function

- Target version changed from CoCoALib-0.99532 to CoCoALib-0.99533 Easter14

#3 - 07 Apr 2014 18:21 - John Abbott

- Target version changed from CoCoALib-0.99533 Easter14 to CoCoALib-0.99534 Seoul14

#4 - 31 Jul 2014 12:40 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.99534 Seoul14 to CoCoALib-1.0

#5 - 15 Sep 2014 11:21 - John Abbott

I found this is an email message (from me) of 20140613:

The (naive) attempt to add a JBMill to an ideal failed dismally :-(

There were several problems:

(1) you cannot have a data member of type std::auto_ptr<JBMill> because

     then the copy ctor won't work;

(2) with C++11 you could use std::shared_ptr instead of auto_ptr...

(3) there were problems with "circular includes": I wanted to add the

      field auto_ptr<JBMill> to IdealImpl in SparsePolyRing.H, but TmpJBMill.H

      already includes SparsePolyRing.H, so the include failed :-(

It might be possible to split SparsePolyRing.H into two files, but I need to

think about this before deciding what to do.
#6 - 15 Sep 2014 12:04 - Anna Maria Bigatti

John Abbott wrote:

I found this is an email message (from me) of 20140613:

(1) you cannot have a data member of type std::auto_ptr<JBMill> because

then the copy ctor won't work;  

(2) with C++11 you could use std::shared_ptr instead of auto_ptr...

 

SmartPtrIRC

(3) there were problems with "circular includes": I wanted to add the

field auto_ptr<JBMill> to IdealImpl in SparsePolyRing.H, but TmpJBMill.H

already includes SparsePolyRing.H, so the include failed :-(

It might be possible to split SparsePolyRing.H into two files, but I need to

think about this before deciding what to do.

 

It'd be worth having the implementation of SparsePolyRing::ideal in a separate file.

This data type is crucial in CoCoA and I think it deserves it's own file ;-)

#7 - 26 Apr 2016 15:11 - John Abbott

- Related to Design #871: Redesign ideals added

#8 - 16 Sep 2016 08:31 - Anna Maria Bigatti

- Related to Design #921: Design GBMill added
